package java.security;

import java.util.NoSuchElementException;
import java.util.Enumeration;
import java.io.Serializable;

public abstract class PermissionCollection implements Serializable
{
    private static final long serialVersionUID = -6727011328946861783L;
    private volatile boolean readOnly;
    
    public PermissionCollection() {
    }
    
    public abstract void add(Permission p0);
    
    public abstract boolean implies(Permission p0);
    
    public abstract Enumeration<Permission> elements();
    
    public void setReadOnly() {
        this.readOnly = true;
    }
    
    public boolean isReadOnly() {
        return this.readOnly;
    }
    
    @Override
    public String toString() {
        Enumeration<Permission> elements = this.elements();
        StringBuilder sb = new StringBuilder();
        sb.append(super.toString() + " (\n");
        while (elements.hasMoreElements()) {
            try {
                sb.append(" ");
                sb.append(((Permission)elements.nextElement()).toString());
                sb.append("\n");
            }
            catch (NoSuchElementException ex) {}
        }
        sb.append(")\n");
        return sb.toString();
    }
}
